--Behaviour()'s variables
local gen_tic = 0			--counts time for sending an electric sign

--behaviour of things
function Behaviour()

	for z=2, #Objects do
	
	--declaring neighbours immediately	
	if Objects[z].Name ~= "'Sample'" then
		L = Field_C[Objects[z].X_Pos-1][Objects[z].Y_Pos]
		R = Field_C[Objects[z].X_Pos+1][Objects[z].Y_Pos]
		U = Field_C[Objects[z].X_Pos][Objects[z].Y_Pos-1]
		D = Field_C[Objects[z].X_Pos][Objects[z].Y_Pos+1]	
	end

	--what generators do (function put into Behav())
	function Generator()
		
				if L ~= 0									--if neighbour has an object
				and Objects[L].Wireworld_Num == 1			--it's a conductor					
				then
					Objects[L].Wireworld_Num = 2 	
				end

				if R ~= 0									
				and Objects[R].Wireworld_Num == 1		
				then
					Objects[R].Wireworld_Num = 2 	
				end

				if U ~= 0									
				and Objects[U].Wireworld_Num == 1		
				then
					Objects[U].Wireworld_Num = 2 	
				end
				
				if D ~= 0									
				and Objects[D].Wireworld_Num == 1		
				then
					Objects[D].Wireworld_Num = 2 	
				end			
	end	
	
	--general behaviours:	
	--increasing Last_Shocked variable for everything that can be a conductor
	if Objects[z].Wireworld_Num ~= 0 then	
	
		--if neighbour isn't empty, and it's an electron head, then zero the value, else increase it by 1
		if L ~= 0 and Objects[L].Wireworld_Num == 2 
		then Objects[z].Last_Shocked = 0 
		else Objects[z].Last_Shocked = Objects[z].Last_Shocked + 1 end
		
		if R ~= 0 and Objects[R].Wireworld_Num == 2 
		then Objects[z].Last_Shocked = 0 
		else Objects[z].Last_Shocked = Objects[z].Last_Shocked + 1 end

		if U ~= 0 and Objects[U].Wireworld_Num == 2 
		then Objects[z].Last_Shocked = 0 
		else Objects[z].Last_Shocked = Objects[z].Last_Shocked + 1 end

		if D ~= 0 and Objects[D].Wireworld_Num == 2 
		then Objects[z].Last_Shocked = 0 
		else Objects[z].Last_Shocked = Objects[z].Last_Shocked + 1 end		
	
	end
	
	--create generator from everything that should
	if Objects[z].Generator then Generator() end
		
	--generators
		if Objects[z].Name == ObjectNameFunction(3) then	
				
			Generator()
		end
		
	--wires: see at Wireworld()	
	
	--lamps
		if Objects[z].Name == ObjectNameFunction(5) then			

			if (L~=0 and Objects[L].Wireworld_Num == 2)	--if neighbour isn't empty and it's an electronhead
			or (R~=0 and Objects[R].Wireworld_Num == 2)	--ANY of the neighbours
			or (U~=0 and Objects[U].Wireworld_Num == 2)
			or (D~=0 and Objects[D].Wireworld_Num == 2)
			then
				Objects[z].Current_Sprite_Num = 43
			else										--else ONLY if it didn't get electricity for a while
				if Objects[z].Last_Shocked > 100				
				then
					Objects[z].Current_Sprite_Num = 27	
				end			
			end
			
		end
	
	--local batteries
		if Objects[z].Name == ObjectNameFunction(6) then	
			
			gen_tic = gen_tic+1
			
			if gen_tic == 10 then		
				Generator()
				gen_tic = 0
			end
		
		end
	
	end
	
end

--behaviour of wires -> WIREWORLD AUTOMATON
--CALLING OF THIS MOTHERFUCKER IS PUT INTO TEXTURE_ANIMATION.LUA!
function Wireworld()

	for z=2, #Objects do
	
		Ngbh = 0

		--declaring neighbours immediately	
		if Objects[z].Name ~= "'Sample'" then
			L = Field_C[Objects[z].X_Pos-1][Objects[z].Y_Pos]
			R = Field_C[Objects[z].X_Pos+1][Objects[z].Y_Pos]
			U = Field_C[Objects[z].X_Pos][Objects[z].Y_Pos-1]
			D = Field_C[Objects[z].X_Pos][Objects[z].Y_Pos+1]	
		end		

			--rule of emptyness
			if Objects[z].Wireworld_Num == 4 then
				ObjectsWire[z] = 4
				break
				
			--rule of conductor
			elseif Objects[z].Wireworld_Num == 1 then
				--conunting neighbours
				if L ~= 0 and Objects[L].Wireworld_Num == 2 then
					Ngbh = Ngbh + 1
				end
				
				if R ~= 0 and Objects[R].Wireworld_Num == 2 then
					Ngbh = Ngbh + 1
				end		

				if U ~= 0 and Objects[U].Wireworld_Num == 2 then
					Ngbh = Ngbh + 1
				end
				
				if D ~= 0 and Objects[D].Wireworld_Num == 2 then
					Ngbh = Ngbh + 1
				end	
				
				if Ngbh == 1 or Ngbh == 2 then
					ObjectsWire[z] = 2
				else
					ObjectsWire[z] = 1
				end
				
			--rule of e-head
			elseif Objects[z].Wireworld_Num == 2 then
				ObjectsWire[z] = 3
								
			--rule of e-tail
			elseif Objects[z].Wireworld_Num == 3 then
				ObjectsWire[z] = 1			
			end	

	end

	--loading datas back
	for z=2, #Objects do
		Objects[z].Wireworld_Num = ObjectsWire[z]
	end
	
	--retexturing
	for z=2, #Objects do
			if Objects[z].Type_ID == 4 then
				if Objects[z].Wireworld_Num == 1 then
					Objects[z].Current_Sprite_Num = 80
				elseif Objects[z].Wireworld_Num == 2 then
					Objects[z].Current_Sprite_Num = 64	
				elseif Objects[z].Wireworld_Num == 3 then
					Objects[z].Current_Sprite_Num = 64					
				end	
			end
	end	
	
end

