-- key bindings
function love.keypressed(key)

	if key == 'escape'
	then
		love.event.push('quit')
	end

	-- move with player
	
	if key == "w" and 3 <= Player.Y_Pos
	then
		SolidChecker(Player.X_Pos,Player.Y_Pos - 1, "up")
		Player.Current_Sprite_Num = 17
		
		if Player.Can_I_Move == true
		then	

			--move object on NextTileNum away - if can
			if Field_C[Player.X_Pos][Player.Y_Pos - 1] ~= 0
			then
				if Objects[Field_C[Player.X_Pos][Player.Y_Pos - 1]].Can_I_Move
				then
					Objects[Field_C[Player.X_Pos][Player.Y_Pos - 1]].Y_Pos = Objects[Field_C[Player.X_Pos][Player.Y_Pos - 1]].Y_Pos - 1
					Field_C[Player.X_Pos][Player.Y_Pos - 1] = 0
				end
			end
			
			Player.Y_Pos = Player.Y_Pos - 1

			--if there's an object, draw that, if empty, draw empty			
			if Field_C[Player.X_Pos][Player.Y_Pos + 1] == 0 then
				Field_B[Player.X_Pos][Player.Y_Pos + 1] = 16
			else
				Field_B[Player.X_Pos][Player.Y_Pos + 1] = Objects[Field_C[Player.X_Pos][Player.Y_Pos + 1]].Current_Sprite_Num
			end
			
			--offset
			if Player.Y_Pos - GameField_OffsetY <= 8 --number of tiles from the upper edge of the screen should be smaller than 8
			and GameField_OffsetY > 1				--offset should be bigger than 0
			then
				GameField_OffsetY = GameField_OffsetY - 1
			end
		end
	end

	if key == "s" and Player.Y_Pos <= Max_col_length - 1
	then
		SolidChecker(Player.X_Pos,Player.Y_Pos + 1, "down")
		Player.Current_Sprite_Num = 33
		
		if Player.Can_I_Move
		then

			--move object on NextTileNum away - if can
			if Field_C[Player.X_Pos][Player.Y_Pos + 1] ~= 0
			then
				if Objects[Field_C[Player.X_Pos][Player.Y_Pos + 1]].Can_I_Move
				then
					Objects[Field_C[Player.X_Pos][Player.Y_Pos + 1]].Y_Pos = Objects[Field_C[Player.X_Pos][Player.Y_Pos + 1]].Y_Pos + 1
					Field_C[Player.X_Pos][Player.Y_Pos + 1] = 0
				end
			end
			
			Player.Y_Pos = Player.Y_Pos + 1
			
			--if there's an object, draw that, if empty, draw empty
			if Field_C[Player.X_Pos][Player.Y_Pos - 1] == 0 then
				Field_B[Player.X_Pos][Player.Y_Pos - 1] = 16
			else
				Field_B[Player.X_Pos][Player.Y_Pos - 1] = Objects[Field_C[Player.X_Pos][Player.Y_Pos - 1]].Current_Sprite_Num
			end

			--offset
			if Player.Y_Pos - GameField_OffsetY > ScreenSizeY - 8 	--number of tiles from the upper edge of the screen should be bigger than screen size minus 8
			and GameField_OffsetY < Max_col_length - ScreenSizeY 	--offset should be smaller than the full size minus screen size
			then
				GameField_OffsetY = GameField_OffsetY + 1
			end
		end
		
	end

	if key == "a" and 3 <= Player.X_Pos 
	then
		SolidChecker(Player.X_Pos - 1,Player.Y_Pos, "left")
		Player.Current_Sprite_Num = 18
		
		if Player.Can_I_Move
		then
		
			--move object on NextTileNum away - if can
			if Field_C[Player.X_Pos - 1][Player.Y_Pos] ~= 0
			then
				if Objects[Field_C[Player.X_Pos - 1][Player.Y_Pos]].Can_I_Move
				then
					Objects[Field_C[Player.X_Pos - 1][Player.Y_Pos]].X_Pos = Objects[Field_C[Player.X_Pos - 1][Player.Y_Pos]].X_Pos - 1
					Field_C[Player.X_Pos - 1][Player.Y_Pos] = 0
				end
			end	
		
			Player.X_Pos = Player.X_Pos - 1
			
			--if there's an object, draw that, if empty, draw empty
			if Field_C[Player.X_Pos + 1][Player.Y_Pos] == 0 then
				Field_B[Player.X_Pos + 1][Player.Y_Pos] = 16
			else
				Field_B[Player.X_Pos + 1][Player.Y_Pos] = Objects[Field_C[Player.X_Pos + 1][Player.Y_Pos]].Current_Sprite_Num
			end

			--offset
			if Player.X_Pos - GameField_OffsetX <= 8 	--number of tiles from the upper edge of the screen should be smaller than 8
			and GameField_OffsetX > 1					--offset should be bigger than 0
			then
				GameField_OffsetX = GameField_OffsetX - 1
			end
		end
				
	end

	if key == "d" and Player.X_Pos <= Max_row_length - 1
	then
		SolidChecker(Player.X_Pos + 1,Player.Y_Pos, "right")
		Player.Current_Sprite_Num = 34
		
		if Player.Can_I_Move
		then

			--move object on NextTileNum away - if can
			if Field_C[Player.X_Pos + 1][Player.Y_Pos] ~= 0
			then
				if Objects[Field_C[Player.X_Pos + 1][Player.Y_Pos]].Can_I_Move
				then
					Objects[Field_C[Player.X_Pos + 1][Player.Y_Pos]].X_Pos = Objects[Field_C[Player.X_Pos + 1][Player.Y_Pos]].X_Pos + 1
					Field_C[Player.X_Pos + 1][Player.Y_Pos] = 0
				end
			end	
			
			Player.X_Pos = Player.X_Pos + 1	
			
			--if there's an object, draw that, if empty, draw empty
			if Field_C[Player.X_Pos - 1][Player.Y_Pos] == 0 then
				Field_B[Player.X_Pos - 1][Player.Y_Pos] = 16
			else
				Field_B[Player.X_Pos - 1][Player.Y_Pos] = Objects[Field_C[Player.X_Pos - 1][Player.Y_Pos]].Current_Sprite_Num
			end

			--offset
			if Player.X_Pos - GameField_OffsetX > ScreenSizeX - 8 	--number of tiles from the upper edge of the screen should be bigger than screen size minus 8
			and GameField_OffsetX < Max_row_length - ScreenSizeX 	--offset should be smaller than the full size minus screen size
			then
				GameField_OffsetX = GameField_OffsetX + 1
			end
		end
	end	

	if key == "m" then
		Definer()
		SaveMap()
	end
	
	if key == "n" then
		LoadMap()
	end	
	
end
 
