function MouseBehaviour()

	MouseX = love.mouse.getX()
	MouseY = love.mouse.getY()
	
	ChosenTile_X = math.floor((MouseX+16)/32) + GameField_OffsetX
	ChosenTile_Y = math.floor((MouseY+16)/32) + GameField_OffsetY
	
	-- if cursor is within GameField
	if (16 < MouseX and MouseX < 768+16) 
	and (16 < MouseY and MouseY < 512+16) 
	then
		MouseInIt = true											--write out values declared above
		ChosenTile_A_Num = Field_A[ChosenTile_X][ChosenTile_Y]		--calculate the A-num of the tile I'm on
																	--dealing with edit cursor
		EditorCursor.X_Pos = ChosenTile_X											
		EditorCursor.Y_Pos = ChosenTile_Y
		
	else 
		MouseInIt = false
	end
	
	--put static things onto the playfield
	if MouseInIt then 
		if love.mouse.isDown("l") then
			Field_A[EditorCursor.X_Pos][EditorCursor.Y_Pos] = EditorCursor.Selected_Tilenum
		end
	end
	
	
	--click events
	function love.mousepressed( x, y, button )

		if (HUD_Arrow["Left"].Scr_X < MouseX and MouseX < HUD_Arrow["Left"].Scr_X+32) 
		and (HUD_Arrow["Left"].Scr_Y < MouseY and MouseY < HUD_Arrow["Left"].Scr_Y+32) 
		then

			if button == "l" and EditorCursor.Selected_Tilenum>1 then
				EditorCursor.Selected_Tilenum = EditorCursor.Selected_Tilenum -1
			elseif button == "r" and EditorCursor.Selected_Tilenum>8 then
				EditorCursor.Selected_Tilenum = EditorCursor.Selected_Tilenum -8			
			end	
		
		end

		if (HUD_Arrow["Right"].Scr_X < MouseX and MouseX < HUD_Arrow["Right"].Scr_X+32) 
		and (HUD_Arrow["Right"].Scr_Y < MouseY and MouseY < HUD_Arrow["Right"].Scr_Y+32) 
		then

			if button == "l" and EditorCursor.Selected_Tilenum<16*16 then
				EditorCursor.Selected_Tilenum = EditorCursor.Selected_Tilenum +1
			elseif button == "r" and EditorCursor.Selected_Tilenum<16*16-8 then
				EditorCursor.Selected_Tilenum = EditorCursor.Selected_Tilenum +8					
			end	
		
		end	
		
		--put dinamic things onto the playfield
		if MouseInIt 			
		and button == "r" 
		and Field_C[EditorCursor.X_Pos][EditorCursor.Y_Pos] == 0
		then
			Objects[ObjectCounter].X_Pos = EditorCursor.X_Pos
			Objects[ObjectCounter].Y_Pos = EditorCursor.Y_Pos		
			Objects[ObjectCounter].Name = ObjectNameFunction(EditorCursor.Selected_Tilenum)

			SingleDefiner(ObjectCounter)
			ObjectCounter = ObjectCounter + 1
		end
	end
end