--list of numbers, contains the number of those textures which are 
--considered as solid (impassable) tiles

--solid tiles
Solid_Tiles = { 4,6,8,24 }
--solid objects
Solid_Objects = { 4,17 }

--needs two numbers: x and y coordinates of the field
function SolidChecker(x,y, dir)

--defining block beyond the tile where I want to step

	X_Beyond, Y_Beyond = 0,0

	if dir == "up" then
		X_Beyond = x
		Y_Beyond = y - 1
	elseif dir == "down" then
		X_Beyond = x
		Y_Beyond = y + 1	
	elseif dir == "left" then
		X_Beyond = x - 1
		Y_Beyond = y
	elseif dir == "right" then
		X_Beyond = x + 1		
		Y_Beyond = y
	end	
	
--with the given nums, the function checks then that is the exactly selected object able to move?
	if Field_C[x][y] ~= 0 												--tile next to me has an object
	and (Objects[Field_C[x][y]].Can_I_Move == false						--case 1: object there can't move
	or (Field_C[X_Beyond][Y_Beyond] ~= 0 								--case 2: "beyond-tile" has an object
		and Objects[Field_C[x][y]].Can_I_Move == true))					--"next-tile" object can move
	then
		Player.Can_I_Move = false
		
	else
		Player.Can_I_Move = true
		
	end

--with the given nums, the function checks then the type of the object - if it still can move
	if Player.Can_I_Move == true then
		for j=1, #Solid_Objects do

			if Field_B[x][y] == Solid_Objects[j] 											--obstacle next to player
			or (Field_C[x][y] ~= 0 and Field_B[X_Beyond][Y_Beyond] == Solid_Objects[j])	--obstacle next to the object I want to push
			then
				Player.Can_I_Move = false
				break
			else
				Player.Can_I_Move = true
			end	
		end	
	end
	
--with the given nums, the function checks the type of the tile - if it still can move
	if Player.Can_I_Move == true then
		for i=1, #Solid_Tiles do
		
			if Field_A[x][y] == Solid_Tiles[i]										--obstacle next to player
			or (Field_C[x][y] ~= 0 and Field_A[X_Beyond][Y_Beyond] == Solid_Tiles[i])	--obstacle next to the object I want to push
			then
				Player.Can_I_Move = false
				break
			else
				Player.Can_I_Move = true
			end	
			
		end	
	end
	
end